# tsn-rt-measures repository

This repository contains various programs I wrote to do TSN measurements

## clockres

clockres is used to determine the resolution of the clock (CLOCK_MONOTONIC), by doing successive
calls to clock_gettime

## packet-exchange

packet-exchange has a client and a server, which exchange UDP ethernet packets using real-time threads,
and can send them on a ETF qdisc by setting a txtime timestamp. Software timestamps can be generated using
the SO_TIMESTAMPING option to measure time spent in kernel.
A Round-Trip Time option also exists to measure RTT of an UDP packet.
XDP sockets can also be used to exchange packets

The client and server programs have a structure similar to cyclictest
They have a real-time thread doing measurements and time sensitive operations 
at regular intervals, and a non real-time thread doing the I/O operations to
report the results shared by the real-time thread.
The real-time thread can be assigned to a CPU and can have it's priority set as
an option, default is to 98.

## motor-control

motor-control was designed for the TSN Motor control demo: https://www.erp5.com/P-OSIE.Blog.TSN.Motor.Control.Demo
